 /***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.services.organization.ldap;

import org.exoplatform.container.xml.InitParams;
import org.exoplatform.services.cache.CacheService;
import org.exoplatform.services.database.HibernateService;
import org.exoplatform.services.ldap.LDAPService;
import org.exoplatform.services.organization.BaseOrganizationService;
import org.exoplatform.services.organization.hibernate.UserProfileHandlerImpl;
/**
 * Created by The eXo Platform SARL
 * Author : Tuan Nguyen
 *          tuan08@users.sourceforge.net
 * Oct 14, 2005
 */
public class OrganizationServiceImpl extends  BaseOrganizationService  {  
  
  public OrganizationServiceImpl(InitParams params, LDAPService ldapService, 
                                 HibernateService hservice, 
                                 CacheService cservice ) throws Exception {    
    
    LDAPAttributeMapping ldapAttrMapping = 
      (LDAPAttributeMapping)params.getObjectParam("ldap.attribute.mapping").getObject();
    
    if(ldapService.getServerType() == LDAPService.ACTIVE_DIRECTORY_SERVER){
      userHandler_ =  new ADUserHandlerImpl(ldapAttrMapping, ldapService);
      ADSearchBySID adSearch = new ADSearchBySID(ldapAttrMapping, ldapService);
      groupHandler_ =  new ADGroupHandlerImpl(ldapAttrMapping, ldapService, adSearch); 
      membershipHandler_ = new ADMembershipHandlerImpl(ldapAttrMapping, ldapService, adSearch);
    } else{
      userHandler_ = new UserHandlerImpl(ldapAttrMapping, ldapService) ;
      groupHandler_ =  new GroupHandlerImpl(ldapAttrMapping, ldapService); 
      membershipHandler_ = new MembershipHandlerImpl(ldapAttrMapping, ldapService) ;
    }    
//    userProfileHandler_ =  new UserProfileHandlerImpl(ldapAttrMapping, ldapService) ;
    userProfileHandler_ =  new UserProfileHandlerImpl(hservice, cservice) ;
    membershipTypeHandler_ = new MembershipTypeHandlerImpl(ldapAttrMapping, ldapService) ;
    
  }
  
  
  
}
