/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portal.config.impl;

import org.exoplatform.container.PortalContainer;
import org.exoplatform.container.component.BaseComponentPlugin;
import org.exoplatform.portal.community.CommunityEventListener;
import org.exoplatform.portal.community.CommunityNavigation;
import org.exoplatform.portal.community.CommunityPortal;
import org.exoplatform.portal.config.PortalConfigService;

/**
 * Created by The eXo Platform SARL
 * Author : Thuannd
 *         nhudinhthuan@yahoo.com
 * Apr 20, 2006
 */
public class CommunityEventListenerImpl extends BaseComponentPlugin implements CommunityEventListener {
  
  public void onChange(CommunityNavigation cn) throws Exception {
    updatePortalConfigService(cn.getGroupId()) ;
  }
  
  public void onChange(CommunityPortal cp) throws Exception {
    updatePortalConfigService(cp.getGroupId()) ;
  } 
  
  private void updatePortalConfigService(String groupId) throws Exception {   
    PortalContainer pcontainer = PortalContainer.getInstance() ;
    PortalConfigService service =
      (PortalConfigService) pcontainer.getComponentInstanceOfType(PortalConfigService.class) ;
    service.onModifiedGroup(groupId) ;
  }
}
