/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portal.config.model;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.exoplatform.services.portletcontainer.pci.model.ExoPortletPreferences;
/**
 * Jun 9, 2004 
 * @author: Tuan Nguyen
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id: ExoPortletPreferences.java,v 1.1 2004/07/13 02:31:13 tuan08 Exp $
 */
public class PortletPreferences  {
  private String creator ;
  private String modifier ;
  
  private String preferencesValidator ;
  private ArrayList preferences ;
  
  public PortletPreferences() {}
  
  public String getCreator() {  return creator ; }
  public void   setCreator(String s) {  creator  = s ; }
  
  public String getModifier() { return modifier ; }
  public void   setModifier(String s) { modifier = s ; }
  
  public PortletPreferences(ExoPortletPreferences prefs) {
    preferencesValidator = prefs.getPreferencesValidator() ;
    if(prefs.size() > 0) {
      preferences = new ArrayList(prefs.size() + 2) ;
      Iterator i = prefs.values().iterator() ;
      while(i.hasNext()) {
        org.exoplatform.services.portletcontainer.pci.model.Preference pref = 
          (org.exoplatform.services.portletcontainer.pci.model.Preference )i.next() ;
        Preference tmp = new Preference() ;
        tmp.setName(pref.getName()) ;
        tmp.setReadOnly(pref.isReadOnly()) ;
        List values = pref.getValues() ;
        if(values != null) {
          for(int j = 0; j < values.size(); j++) {
            tmp.addValue((String)values.get(j)) ;
          }
        }
        preferences.add(tmp) ;
      }
    }
  }
  
	public String getPreferencesValidator() {	return preferencesValidator; }
	public void setPreferencesValidator(String validator) { preferencesValidator = validator;	}
  
  public List getPreferences() { return preferences ; }
  public void setPreferences(ArrayList l) { preferences = l ; }
  
  public ExoPortletPreferences toExoPortletPreferences() {
    ExoPortletPreferences prefs = new ExoPortletPreferences() ;
    prefs.setPreferencesValidator(preferencesValidator) ;
    if(preferences != null) {
      for(int i = 0 ; i < preferences.size(); i++) {
        Preference pref = (Preference) preferences.get(i) ;
        org.exoplatform.services.portletcontainer.pci.model.Preference tmp = 
          new org.exoplatform.services.portletcontainer.pci.model.Preference() ;
        tmp.setName(pref.getName()) ;
        tmp.setReadOnly(pref.isReadOnly()) ;
        List values = pref.getValues() ;
        if(values != null) {
          for(int j = 0; j < values.size(); j++) {
            tmp.addValue((String)values.get(j)) ;
          }
        }
        prefs.addPreference(tmp) ;
      }
    }
    return  prefs ;
  }
}