/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portal.faces.component.logic;

import java.util.List;
import java.util.Locale;
import java.util.ResourceBundle;

import javax.faces.context.FacesContext;
import javax.servlet.http.HttpServletRequest;

import org.exoplatform.container.SessionContainer;
import org.exoplatform.portal.PortalConstants;
import org.exoplatform.portal.faces.component.UIPage;
import org.exoplatform.portal.faces.component.UIPortal;
import org.exoplatform.portal.faces.component.UIPortalComponent;
import org.exoplatform.portal.faces.component.Util;
import org.exoplatform.portal.session.PortalResources;
/**
 * @author Tuan Nguyen (tuan08@users.sourceforge.net)
 * @since Nov 17, 2004
 * @version $Id$
 */
public class PortalLocale {
  /* set default locale */
  static public void changeLocale(UIPortal uiPortal) {
    String lang = uiPortal.getPortalConfigModel().getLocale() ;
    FacesContext context = FacesContext.getCurrentInstance() ;
    HttpServletRequest request = 
      (HttpServletRequest) context.getExternalContext().getRequest();
    String langParam = request.getParameter(PortalConstants.LANGUAGE_PARAMETER) ;
    if(langParam != null) lang = langParam ;
    if (lang == null || lang.length() == 0) {
      Locale requestLocale = request.getLocale() ;
      lang = requestLocale.getLanguage() ;
    }
    changeLocale(uiPortal, lang) ;
  }
  
  static public void changeLocale(UIPortal uiPortal, String locale) {
    PortalResources  presources = 
      (PortalResources) SessionContainer.getComponent(PortalResources.class) ;
    presources.changeLocaleConfig(locale, uiPortal.getOwner()) ;
    ResourceBundle res = presources.getApplicationOwnerResource() ;
    uiPortal.changeLocale(res) ;
    List descendants = Util.findDescendantsOfTypeInPortal(uiPortal, UIPortalComponent.class) ;
    for(int i = 0; i < descendants.size(); i++) {
      UIPortalComponent descendant = (UIPortalComponent) descendants.get(i) ;
      descendant.changeLocale(res) ;
    }
  }
  
  static public void changeLocale(UIPage uiPage) {
    //uipage has error
    if(uiPage.getError() != null)  return ;
    PortalResources  presources = 
      (PortalResources) SessionContainer.getComponent(PortalResources.class) ;
    ResourceBundle res = presources.getLocaleConfig().getOwnerResourceBundle(uiPage.getOwner()) ;
    updateLocale(uiPage, res) ;
  }
  
  static private  void updateLocale(UIPortalComponent component, ResourceBundle res)  {
    component.changeLocale(res) ;
    List descendants = component.findDescendantsOfType(UIPortalComponent.class) ;
    for(int i = 0; i < descendants.size(); i++) {
      UIPortalComponent descendant = (UIPortalComponent) descendants.get(i) ;
      descendant.changeLocale(res) ;
    }
  }
}