/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portal.faces.renderer.html.portal;

import java.io.IOException;
import java.util.ResourceBundle;

import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.context.ResponseWriter;
import javax.servlet.http.HttpServletRequest;

import org.apache.velocity.Template;
import org.apache.velocity.VelocityContext;
import org.exoplatform.Constants;
import org.exoplatform.container.SessionContainer;
import org.exoplatform.faces.application.ExoFacesMessage;
import org.exoplatform.faces.core.component.UIExoComponent;
import org.exoplatform.portal.PortalConstants;
import org.exoplatform.portal.faces.component.UIPortal;
import org.exoplatform.portal.faces.renderer.BaseRenderer;
import org.exoplatform.portal.session.RequestInfo;
import org.exoplatform.services.log.LogUtil;
/**
 * Date: Aug 11, 2003
 * @author : Mestrallet Benjamin
 * @email:   benjmestrallet@users.sourceforge.net
 * @author: Tuan Nguyen
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id: PortalRenderer.java,v 1.11 2004/10/08 18:03:13 benjmestrallet Exp $
 */
public class PortalRenderer extends BaseRenderer {
 
  public void encodeChildren( FacesContext context, UIComponent component ) throws IOException {
    ResponseWriter w = context.getResponseWriter() ;
    ResourceBundle res = getApplicationResourceBundle(context.getExternalContext());
    UIPortal uiPortal = (UIPortal) component ;
    try {
      Template template = getTemplate(component, context) ;
      VelocityContext vcontext = new VelocityContext() ;
      vcontext.put(UIExoComponent.UICOMPONENT, component) ;
      vcontext.put("res", res) ;
      HttpServletRequest request = 
        (HttpServletRequest) context.getExternalContext().getRequest();
      String baseURL = request.getScheme() + "://" + request.getServerName() + ":" +
                       Integer.toString(request.getServerPort()) ;
      vcontext.put("baseURL", baseURL) ;
      String contextPath = request.getContextPath() ;
      vcontext.put("contextPath", contextPath) ;
      if(uiPortal.getPortalMode() ==  UIPortal.PORTAL_EDIT_MODE) {
        RequestInfo rinfo = (RequestInfo) SessionContainer.getComponent(RequestInfo.class);
        String dragDropActionURL = rinfo.getOwnerURI() + "?" +  Constants.COMPONENT_PARAMETER + "=" + uiPortal.getId() +
                                   "&" + PortalConstants.PORTAL_ACTION + "=" + 
                                   PortalConstants.DRAG_DROP_ACTION ;
        vcontext.put("dragDropActionURL", dragDropActionURL) ;
      }
      template.merge(vcontext, w) ;
    } catch (Exception ex) {
      LogUtil.getLog(getClass()).error("Render  Error: ", ex) ;
    }
  }
  
  private String getMessage(UIPortal uiPortal, ResourceBundle res) {
    StringBuffer b = new StringBuffer() ;
    java.util.List messages = uiPortal.getMessages() ;
    for(int i = 0; i < messages.size(); i++) {
      ExoFacesMessage  m = (ExoFacesMessage) messages.get(i) ;
      String s  = m.getSummary(res) ;
      s = s.replace('\"', '*') ;
      b.append(s).append("\\n") ;
    }
    uiPortal.clearMessages() ;
    return b.toString()  ;
  }
}