package org.exoplatform.portal.skin;

import java.io.InputStream;

import javax.portlet.PortletConfig;
import javax.servlet.ServletContext;
import javax.servlet.ServletContextEvent;
import javax.servlet.ServletContextListener;

import org.apache.commons.logging.Log;
import org.exoplatform.container.RootContainer;
import org.exoplatform.container.component.BaseComponentPlugin;
import org.exoplatform.services.log.LogService;
import org.exoplatform.services.portletcontainer.PortletLifecycleListener;
import org.exoplatform.services.portletcontainer.pci.model.PortletApp;

public class SkinListener extends BaseComponentPlugin 
	implements PortletLifecycleListener, ServletContextListener {

  public void contextInitialized(ServletContextEvent event) {
    preDeploy(null, null, event.getServletContext()) ;
  }
  
  public void contextDestroyed(ServletContextEvent arg0) {
    
  }

  public void preDeploy(String appName, PortletApp portletApp, ServletContext scontext) { 
    InputStream is = null;
    RootContainer manager = RootContainer.getInstance();
    LogService lservice = (LogService) manager.getComponentInstanceOfType(LogService.class) ;
    Log log = lservice.getLog("org.exoplatform.services.portletcontainer");
    // look for skin-config and register with the Portal Configuration service
    is = scontext.getResourceAsStream("/WEB-INF/skin-config.xml");
    if (is != null) {
      SkinConfigService pcservice = 
        (SkinConfigService) manager.getComponentInstanceOfType(SkinConfigService.class);
      try {
        pcservice.addConfiguration(is);
        log.info("Register skin configuration.............................");
      } catch (Exception e) {
        log.error(e);
      }
    }
  }

  public void postDeploy(String appName, PortletApp portletApp, ServletContext scontext) { 
    
  }

  public void preInit(PortletConfig arg0) { }

  public void postInit(PortletConfig arg0) { }

  public void preDestroy() {  }

  public void postDestroy() { }

  public void preUndeploy(String appName, PortletApp portletApp, ServletContext arg2) {  }

  public void postUndeploy(String appName, PortletApp portletApp, ServletContext arg2) {   }
}
