package org.exoplatform.portlet.commons.wrapper;
import javax.servlet.ServletConfig;
import javax.servlet.ServletContext;
import java.util.Enumeration;
import org.apache.commons.logging.LogFactory;
import org.apache.commons.logging.Log;

public class ServletConfigWrapper implements ServletConfig{
    protected ServletConfig servletConfig;

    protected static Log log = LogFactory.getLog(ServletConfigWrapper.class);

    public ServletConfigWrapper(ServletConfig servletConfig){
        log.debug("ServletConfigWrapper created");
        this.servletConfig = servletConfig;
    }

    public ServletContext getServletContext() {
        log.debug("Wrapper ServletContext");
        return new ServletContextWrapper(servletConfig.getServletContext());
    }

    //delegate-----

    public String getServletName() {
        return servletConfig.getServletName();
    }


    public String getInitParameter(String string) {
        return servletConfig.getInitParameter(string);
    }

    public Enumeration getInitParameterNames() {
        return servletConfig.getInitParameterNames();
    }

}
