/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.user.component;

import org.exoplatform.faces.core.component.UISimpleForm;
import org.exoplatform.faces.core.component.UIStringInput;
import org.exoplatform.faces.core.component.UITextArea ;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.services.organization.Group;
import org.exoplatform.services.organization.OrganizationService;

/**
 * Sat, Jan 03, 2004 @ 11:16 
 * @author: Tuan Nguyen
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id: UIGroupForm.java,v 1.11 2004/10/21 15:25:17 tuan08 Exp $
 */
public class UIGroupForm extends UISimpleForm {
  private OrganizationService service_ ;
  private Group parentGroup_ ;
  private static String GROUPNAME = "groupName" , LABEL = "label" ,
   DESCRIPTION = "description" ;
  public UIGroupForm(OrganizationService service) throws Exception {
    super("groupForm", "post", null) ;    
    setId("UIGroupForm");
    service_ = service ;
    setRendererType("SimpleFormVelocityRenderer") ;
    add(new UIStringInput(GROUPNAME, "")) ;
    add(new UIStringInput(LABEL, "")) ;
    add(new UITextArea(DESCRIPTION, "")) ;
    addActionListener(SaveUpdateListener.class, SAVE_ACTION) ;
    addActionListener(CancelActionListener.class, CANCEL_ACTION) ;
  }
  
  public void setParentGroup(String parentGroupId) throws Exception {
    if(parentGroupId !=null) {
      parentGroup_  = service_.getGroupHandler().findGroupById(parentGroupId) ;
    } else {
      parentGroup_ = null ;
    }
    getUIStringInput(GROUPNAME).setValue("") ;
    getUIStringInput(DESCRIPTION).setValue("") ;
  }
 
  static public class SaveUpdateListener extends ExoActionListener  {
    public void execute(ExoActionEvent event) throws Exception {
      UIGroupForm uiForm = (UIGroupForm) event.getComponent() ;
      Group group = uiForm.service_.getGroupHandler().createGroupInstance() ;
      group.setGroupName(uiForm.getUIStringInput(GROUPNAME).getValue()) ;
      group.setLabel(uiForm.getUIStringInput(LABEL).getValue()) ;
      group.setDescription(uiForm.getUIStringInput(DESCRIPTION).getValue()) ;
      if (uiForm.parentGroup_ == null) {
        uiForm.service_.getGroupHandler().createGroup(group, true) ;
      } else {
        uiForm.service_.getGroupHandler().addChild(uiForm.parentGroup_, group, true) ;
      }
      UIGroupExplorer uiGroupExplorer = (UIGroupExplorer)uiForm.getSibling(UIGroupExplorer.class) ;
      uiGroupExplorer.update() ;
      uiForm.setRenderedSibling(UIGroupExplorer.class);
    }
  }
  
  static public class CancelActionListener extends ExoActionListener  {
  	public void execute(ExoActionEvent event) throws Exception {
      UIGroupForm uiForm = (UIGroupForm) event.getComponent() ;
  		uiForm.setRenderedSibling(UIGroupExplorer.class);
    }
  }
}