package org.exoplatform.portlets.portal.component;

import java.util.List;

import javax.faces.component.UIComponent;

import org.exoplatform.container.SessionContainer;
import org.exoplatform.faces.core.component.UICommandPortlet;
import org.exoplatform.faces.core.component.UIToolbar;
import org.exoplatform.faces.core.component.model.Button;
import org.exoplatform.faces.core.component.model.Parameter;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.portal.PortalConstants;
import org.exoplatform.portal.config.model.Node;
import org.exoplatform.portal.session.ExoPortal;
/**
 * @version $Revision: 1.8 $ $Date: 2004/10/19 13:20:03 $
 * @author Tuan Nguyen
 */
public class UIPortalModePortlet extends UICommandPortlet {
  static Parameter CHANGE_MODE =   new Parameter(ACTION, "changeMode");
  
  static Parameter[] VIEW_MODE_PARAMS = {CHANGE_MODE,  new Parameter("mode", "normal") };
  static Parameter[] EDIT_NAV_MODE_PARAMS =  {CHANGE_MODE,  new Parameter("mode", "edit-navigation") };
  static Parameter[] EDIT_PORTAL_MODE_PARAMS =  {CHANGE_MODE,  new Parameter("mode", "edit-portal") };
  static Parameter[] EDIT_PAGE_MODE_PARAMS =  {CHANGE_MODE,  new Parameter("mode", "edit-page") };
 
  static Parameter[] BROWSE_PAGE_PARAMS = {new Parameter(ACTION, PortalConstants.BROWSE_PAGE_ACTION) };
  static Parameter[] SAVE_PAGE_PARAMS = {new Parameter(ACTION, PortalConstants.SAVE_PAGE_ACTION) };
  static Parameter[] EDIT_PORTAL_PROPS_PARAMS = {new Parameter(ACTION, PortalConstants.EDIT_PORTAL_ACTION) };
  static Parameter[] SAVE_PORTAL_PARAMS = {new Parameter(ACTION, PortalConstants.SAVE_PORTAL_ACTION) };
  static Parameter[] SAVE_NAV_PARAMS = {new Parameter(ACTION, PortalConstants.SAVE_NODE_ACTION) };
  static Parameter[] MOVE__NODE_UP_PARAMS = {new Parameter(ACTION, PortalConstants.MOVE_UP_NODE_ACTION) };
  static Parameter[] MOVE_NODE_DOWN_PARAMS = {new Parameter(ACTION, PortalConstants.MOVE_DOWN_NODE_ACTION) };
  static Parameter[] EDIT_NODE_PARAMS = {new Parameter(ACTION, PortalConstants.EDIT_NODE_ACTION) };
  static Parameter[] DELETE_NODE_PARAMS = {new Parameter(ACTION, PortalConstants.DELETE_NODE_ACTION) };
  static Parameter[] ADD_NODE_PARAMS = {new Parameter(ACTION, PortalConstants.ADD_NODE_ACTION) };
  static Parameter[] SHOW_NAV_PARAMS = {new Parameter(ACTION, PortalConstants.SHOW_NAVIGATION_ACTION) };
  
  private UIToolbar uiToolbarView_;
  private UIToolbar uiToolbarPortal_;
  private UIToolbar uiToolbarNav_;
  private UIToolbar uiToolbarPage_;
  
	public UIPortalModePortlet() throws Exception {
		setId("UIPortalModePortlet");
		setRendererType("ChildrenRenderer");
    
    ExoPortal portal = (ExoPortal) SessionContainer.getComponent(ExoPortal.class) ;
    boolean editPortal  = portal.hasEditPortalCapability() ;
    boolean editNav = portal.hasEditNavigationCapability()  ;
    if(!(editPortal || editNav))  return ;
    
    List children = getChildren() ;
    uiToolbarView_ = new UIToolbar("UIToolbarView");  
    uiToolbarView_.setRendered(true);
    if(editPortal) {
      uiToolbarView_.addRightButton(new Button("#{UIPortalModePortlet.button.portal-mode}", EDIT_PORTAL_MODE_PARAMS));
      uiToolbarPortal_ = new UIToolbar("UIToolbarPortal");
      uiToolbarPortal_.addLeftButton(new Button("#{UIPortalModePortlet.button.edit-portal-properties}", EDIT_PORTAL_PROPS_PARAMS));
      uiToolbarPortal_.addLeftButton(new Button("#{UIPortalModePortlet.button.save-portal}", SAVE_PORTAL_PARAMS));
      uiToolbarPortal_.addRightButton(new Button("#{UIPortalModePortlet.button.view-mode}", VIEW_MODE_PARAMS));
      uiToolbarPortal_.setRendered(true);
    }
    
    if(editNav) {
      uiToolbarView_.addRightButton(new Button("#{UIPortalModePortlet.button.navigation-mode}", EDIT_NAV_MODE_PARAMS));
      
      uiToolbarNav_ = new UIToolbar("UIToolbarNav");
      uiToolbarNav_.addLeftButton(new Button("#{UIPortalModePortlet.button.browse-pages}", BROWSE_PAGE_PARAMS));
      uiToolbarNav_.addLeftButton(new Button("#{UIPortalModePortlet.button.save-navigation}", SAVE_NAV_PARAMS));
      uiToolbarNav_.addLeftButton(new Button("#{UIPortalModePortlet.button.show_nav}", SHOW_NAV_PARAMS));
      uiToolbarNav_.addRightButton(new Button("#{UIPortalModePortlet.button.view-mode}", VIEW_MODE_PARAMS));
      uiToolbarNav_.setRendered(true);
      
      uiToolbarView_.addRightButton(new Button("#{UIPortalModePortlet.button.page-mode}", EDIT_PAGE_MODE_PARAMS));
      uiToolbarPage_ = new UIToolbar("UIToolbarPage");
      uiToolbarPage_.addLeftButton(new Button("#{UIPortalModePortlet.button.browse-pages}", BROWSE_PAGE_PARAMS));
      uiToolbarPage_.addLeftButton(new Button("#{UIPortalModePortlet.button.save-page}", SAVE_PAGE_PARAMS));
      uiToolbarPage_.addRightButton(new Button("#{UIPortalModePortlet.button.view-mode}", VIEW_MODE_PARAMS));
      uiToolbarPage_.setRendered(true);
    }
    children.add(uiToolbarView_);
    
    addActionListener(ForwardPortalEventActionListener.class, PortalConstants.SAVE_PAGE_ACTION) ;            
    addActionListener(ForwardPortalEventActionListener.class, PortalConstants.EDIT_PORTAL_ACTION) ;
    addActionListener(ForwardPortalEventActionListener.class, PortalConstants.SAVE_PORTAL_ACTION) ;
    addActionListener(ForwardPortalEventActionListener.class, PortalConstants.SAVE_NODE_ACTION) ;
    
    addActionListener(ForwardPortalEventActionListener.class, PortalConstants.BROWSE_PAGE_ACTION) ;
    addActionListener(ForwardNodeEventActionListener.class, PortalConstants.SHOW_NAVIGATION_ACTION) ;
    addActionListener(ChangeModeActionListener.class, "changeMode") ;
	}
  
	public void setViewModeRenderer() {  
    List children = getChildren() ;
    children.remove(0);
    children.add(uiToolbarView_);
  }
	
	public void setEditPortalModeRenderer() {  
    List children = getChildren() ;
    children.remove(0);
    children.add(uiToolbarPortal_);    
  }
	
	public void setEditPageModeRenderer() {  
    List children = getChildren() ;
    children.remove(0);
    children.add(uiToolbarPage_);    
  }
	
	public void setEditNavigationModeRenderer() {  
    List children = getChildren() ;
    children.remove(0);
    children.add(uiToolbarNav_);    
  }
  
  static public class ForwardPortalEventActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      ExoPortal portal = (ExoPortal) SessionContainer.getComponent(ExoPortal.class) ;
      ExoActionEvent portalEvent = new ExoActionEvent((UIComponent)portal, getActionName()) ;
      portal.queueEvent(portalEvent) ;
    }
  }
  
  static public class ForwardNodeEventActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      ExoPortal portal = (ExoPortal) SessionContainer.getComponent(ExoPortal.class) ;
      ExoActionEvent portalEvent = new ExoActionEvent((UIComponent)portal, getActionName()) ;
      Node node = portal.getSelectedNode();
      portalEvent.addParameter(PortalConstants.NODE_URI, node.getUri()) ;
      portal.queueEvent(portalEvent) ;
    }
  }
  
  static public class ChangeModeActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UIPortalModePortlet uiNavigation = (UIPortalModePortlet) event.getSource() ;
      String mode = event.getParameter("mode");
      ExoPortal portal = (ExoPortal)SessionContainer.getComponent(ExoPortal.class) ;
      if("edit-navigation".equals(mode)) {
        portal.setPortalMode(ExoPortal.PORTAL_EDIT_NAVIGATION_MODE) ;
        uiNavigation.setEditNavigationModeRenderer() ;
      } else if("edit-portal".equals(mode)) {
        portal.setPortalMode(ExoPortal.PORTAL_EDIT_MODE) ;
        uiNavigation.setEditPortalModeRenderer() ;
      } else if("edit-page".equals(mode)) {
        portal.setPortalMode(ExoPortal.PORTAL_EDIT_PAGE_MODE) ;
        uiNavigation.setEditPageModeRenderer() ;
      } else {
        portal.setPortalMode(ExoPortal.PORTAL_VIEW_MODE) ;
        uiNavigation.setViewModeRenderer() ;
      }
    }
  }
}