/**
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 */

package org.exoplatform.services.portletcontainer.test.filters;

import java.util.*;
import javax.servlet.http.HttpServletRequest;
import org.exoplatform.Constants;
import javax.portlet.PortletMode;
import javax.portlet.WindowState;

/**
 * Created by The eXo Platform SARL .
 * 
 * @author <a href="mailto:lautarul@gmail.com">Roman Pedchenko</a>
 * @version $Id$
 */

public class Helper {

  static public void parseParams(HttpServletRequest httpRequest, HashMap portalParams, HashMap portletParams) {
    Enumeration pNames = httpRequest.getParameterNames();
    while (pNames.hasMoreElements()) {
      String n = (String) pNames.nextElement();
      if (n.startsWith(Constants.PARAMETER_ENCODER))
        portalParams.put(n, httpRequest.getParameter(n));
      else
        portletParams.put(n, httpRequest.getParameter(n));
    }
  }

  static public boolean getActionType(String v) {
    return (v != null) && v.toLowerCase().equals("action");
  }

  static public PortletMode getPortletMode(String v) {
    if (v == null)
      return PortletMode.VIEW;
    if (v.toLowerCase().equals(PortletMode.EDIT.toString()))
      return PortletMode.EDIT;
    if (v.toLowerCase().equals(PortletMode.HELP.toString()))
      return PortletMode.HELP;
    return PortletMode.VIEW;
  }

  static public WindowState getWindowState(String v) {
    if (v == null)
      return WindowState.NORMAL;
    if (v.toLowerCase().equals(WindowState.MAXIMIZED.toString()))
      return WindowState.MAXIMIZED;
    if (v.toLowerCase().equals(WindowState.MINIMIZED.toString()))
      return WindowState.MINIMIZED;
    return WindowState.NORMAL;
  }

}
