package org.esupportail.cas.server.handlers.test;

import org.dom4j.Element;
import org.esupportail.cas.server.util.BasicHandler;

/**
 * This class implements an 'empty password' handler class. It is used by
 * GenericHandler for debugging purposes.
 *
 * @author Pascal Aubry <pascal.aubry at univ-rennes1.fr>
 */
public final class EmptyPasswordHandler extends BasicHandler {
	
	/**
	 * Constructor.
	 *
	 * @param handlerElement the XML element that declares the handler 
	 * in the configuration file
	 * @param configDebug debugging mode of the global configuration
	 */
	public EmptyPasswordHandler(
			final Element handlerElement, 
			final Boolean configDebug) {
		super(handlerElement, configDebug);
		traceBegin();
		traceEnd();
	}
	
	/**
	 * Try to authenticate a user.
	 *
	 * @param username the user's name
	 * @param password the user's password
	 *
	 * @return BasicHandler.SUCCEDED if an empty password was provided, 
	 * or BasicHandler.FAILED_CONTINUE otherwise.
	 */	
	public int authenticate(final String username,
			final String password) {
		traceBegin();
		if (password.equals("")) {
			traceEnd("SUCCEEDED");
			return SUCCEEDED;
		} else {
			traceEnd("FAILED_CONTINUE");
			return FAILED_CONTINUE;
		}
	}
	
}
