/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.test.web.servlet;

import groovy.lang.GroovyClassLoader;

import java.io.IOException;
import java.net.URL;

import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
/**
 * Created by The eXo Platform SARL        .
 * Sun, Dec 28, 2003 @ 14:57 
 * @author: Tuan Nguyen
 * @version: $Id: FileContentServlet.java,v 1.3 2004/06/23 03:19:01 tuan08 Exp $
 * @email: tuan08@yahoo.com
 */
public class ControllerServlet extends HttpServlet {
  Configuration  conf_ ;
  
  public void init(ServletConfig config) throws ServletException {
    String configClass = config.getInitParameter("config.class") ;
    if(configClass == null) {
      throw  new ServletException("No Configuration") ;
    }
    try {
      ClassLoader threadCl =  Thread.currentThread().getContextClassLoader();
      GroovyClassLoader classloader =  new GroovyClassLoader(threadCl) ;
      String groovyPath = config.getServletContext().getRealPath("/WEB-INF/classes") ;
      classloader.addClasspath(groovyPath) ;
      groovyPath = config.getServletContext().getRealPath("/groovy") ;
      classloader.addClasspath(groovyPath) ;
      if(configClass.endsWith(".groovy")) {
        URL  classURL = config.getServletContext().getResource("/groovy/" + configClass) ;
        Class clazz = classloader.parseClass(classURL.openStream()) ;
        conf_ = (Configuration) clazz.newInstance() ;
      } else {
        Class clazz = Class.forName(configClass);
        conf_ = (Configuration) clazz.newInstance() ;
      }
      conf_.setResourceManager(new WebappGroovyResourceManager(classloader, config.getServletContext())) ;
      conf_.configure(this) ;
    } catch(Exception ex) {
      ex.printStackTrace();
      throw new ServletException(ex) ;
    }
  }
  
  public void service(HttpServletRequest request, HttpServletResponse response) 
  throws ServletException, IOException {
    try {
      response.setHeader("Cache-Control", "no-cache");
      String action = request.getParameter("action") ;
      ActionHandler handler = conf_.getActionHandler(action);
      handler.execute(request, response) ;
    } finally {
      conf_.getResourceManager().clearTemplateBinding() ;
    }
  }
  
}
