package org.exoplatform.maven.plugin;

import java.util.* ;
import java.io.* ;
import org.apache.commons.jelly.*;
import org.apache.maven.jelly.MavenJellyContext ;
import org.exoplatform.tools.xml.webapp.v23.ModifyWebXMLOperation;

public class AddExoPortletConfig extends TagSupport {
  private static String WEB_CONFIG = File.separator + "WEB-INF" + File.separator + "web.xml" ;
  private String warName_ ;
  
  public AddExoPortletConfig() {  }

  public void doTag(XMLOutput arg0) throws JellyTagException {
    MavenJellyContext jcontext = (MavenJellyContext)getContext() ;
    ClassLoader old = Thread.currentThread().getContextClassLoader() ;
    Thread.currentThread().setContextClassLoader(ModifyWebXMLOperation.class.getClassLoader()) ;
    System.out.println(ModifyWebXMLOperation.class.getClassLoader()) ;
    String buildTarget = jcontext.getVariable("maven.build.dir").toString();
    String artifactId = jcontext.getProject().getArtifactId() ;
    ModifyWebXMLOperation op = new ModifyWebXMLOperation(warName_);
    String file = buildTarget + File.separator + artifactId + WEB_CONFIG ; 
    File webxml = new File(file) ;
    try {
      op.modifyWebXML(webxml, webxml);
    } catch (Throwable ex) {
      ex.printStackTrace() ;
      throw new JellyTagException(ex) ;
    } finally {
      Thread.currentThread().setContextClassLoader(old) ;
    }
    //System.out.println("property: maven.build.dir " + buildTarget) ;
    //System.out.println("artifactid:  " + artifactId) ;
  }

  public String getWarName() { return this.warName_ ; }
  public void   setWarName(String s) { this.warName_ = s ; }
}
